/**************************************************************************************94x78**
**
** This file may be distributed and/or modified under the terms of the GNU General Public
** License version 2 as published by the Free Software Foundation and appearing in the file
** LICENSE.GPL included in the packaging of this file.
**
** This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE WARRANTY OF DESIGN,
** MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
**
*********************************************************************************************/
#include "sidplayer.h"

#include <qpushbutton.h>
#include <qlabel.h>
#include <qslider.h>
#include <qcheckbox.h>


void Sidplayer::vol1Changed( int vol )
{
    vol1 = 256 - vol;
    Vol1Label->setText( QString::number( vol1 ) );
    myEmuEngine.setVoiceVolume( 1, pan1L, pan1R, vol1 );
}

void Sidplayer::vol2Changed( int vol )
{
    vol2 = 256 - vol;
    Vol2Label->setText( QString::number( vol2 ) );
    myEmuEngine.setVoiceVolume( 2, pan2L, pan2R, vol2 );
}

void Sidplayer::vol3Changed( int vol )
{
    vol3 = 256 - vol;
    Vol3Label->setText( QString::number( vol3 ) );
    myEmuEngine.setVoiceVolume( 3, pan3L, pan3R, vol3 );
}

void Sidplayer::vol4Changed( int vol )
{
    vol4 = 256 - vol;
    Vol4Label->setText( QString::number( vol4 ) );
    myEmuEngine.setVoiceVolume( 4, pan4L, pan4R, vol4 );
}

//--------------------------------------------------------------------------------------------

void Sidplayer::pan1Changed( int pan )
{
    if ( pan > 255 )
    {
        pan1L = 511 - pan;
        pan1R = 255;
    }
    else
    {
        pan1L = 255;
        pan1R = pan;
    }
    Pan1L->setText( QString::number( pan1L ) );
    Pan1R->setText( QString::number( pan1R ) );
    myEmuEngine.setVoiceVolume( 1, pan1L, pan1R, vol1 );
}

void Sidplayer::pan2Changed( int pan )
{
    if ( pan > 255 )
    {
        pan2L = 511 - pan;
        pan2R = 255;
    }
    else
    {
        pan2L = 255;
        pan2R = pan;
    }
    Pan2L->setText( QString::number( pan2L ) );
    Pan2R->setText( QString::number( pan2R ) );
    myEmuEngine.setVoiceVolume(2, pan2L, pan2R, vol2);
}

void Sidplayer::pan3Changed( int pan )
{
    if ( pan > 255 )
    {
        pan3L = 511 - pan;
        pan3R = 255;
    }
    else
    {
        pan3L = 255;
        pan3R = pan;
    }
    Pan3L->setText( QString::number( pan3L ) );
    Pan3R->setText( QString::number( pan3R ) );
    myEmuEngine.setVoiceVolume( 3, pan3L, pan3R, vol3 );
}

void Sidplayer::pan4Changed( int pan )
{
    if ( pan > 255 )
    {
        pan4L = 511 - pan;
        pan4R = 255;
    }
    else
    {
        pan4L = 255;
        pan4R = pan;
    }
    Pan4L->setText( QString::number( pan4L ) );
    Pan4R->setText( QString::number( pan4R ) );
    myEmuEngine.setVoiceVolume( 4, pan4L, pan4R, vol4 );
}

//--------------------------------------------------------------------------------------------

void Sidplayer::mute1Toggled( bool on )
{
    if ( on )
    {
        vol1save = vol1;
        Vol1->setValue( 256 - 0 ); // is mute
        Vol1->setEnabled( false );
    }
    else
    {
        Vol1->setEnabled( true );
        Vol1->setValue( 256 - vol1save );
#ifdef SOLO_GET_RIGHT_HACK
        soloGetRight( 1 );
#endif
    }
}

void Sidplayer::mute2Toggled( bool on )
{
    if ( on )
    {
        vol2save = vol2;
        Vol2->setValue( 256 - 0 ); // is mute
        Vol2->setEnabled( false );
    }
    else
    {
        Vol2->setEnabled( true );
        Vol2->setValue( 256 - vol2save );
#ifdef SOLO_GET_RIGHT_HACK
        soloGetRight( 2 );
#endif
    }
}

void Sidplayer::mute3Toggled( bool on )
{
    if ( on )
    {
        vol3save = vol3;
        Vol3->setValue( 256 - 0 ); // is mute
        Vol3->setEnabled( false );
    }
    else
    {
        Vol3->setEnabled( true );
        Vol3->setValue( 256 - vol3save );
#ifdef SOLO_GET_RIGHT_HACK
        soloGetRight( 3 );
#endif
    }
}

void Sidplayer::mute4Toggled( bool on )
{
    if ( on )
    {
        vol4save = vol4;
        Vol4->setValue( 256 - 0 ); // is mute
        Vol4->setEnabled( false );
    }
    else
    {
        Vol4->setEnabled( true );
        Vol4->setValue( 256 - vol4save );
#ifdef SOLO_GET_RIGHT_HACK
        soloGetRight( 4 );
#endif
    }
}

#ifdef SOLO_GET_RIGHT_HACK
void Sidplayer::soloGetRight( int muteReleased )
{
    if ( muteReleased != 1 && Solo1->isOn() )
    {
        Solo1->blockSignals( true );
        Solo1->setOn( false );
        Solo1->blockSignals( false );
    }
    else if ( muteReleased != 2 && Solo2->isOn() )
    {
        Solo2->blockSignals( true );
        Solo2->setOn( false );
        Solo2->blockSignals( false );
    }
    else if ( muteReleased != 3 && Solo3->isOn() )
    {
        Solo3->blockSignals( true );
        Solo3->setOn( false );
        Solo3->blockSignals( false );
    }
    else if ( muteReleased != 4 && Solo4->isOn() )
    {
        Solo4->blockSignals( true );
        Solo4->setOn( false );
        Solo4->blockSignals( false );
    }
}
#endif

//--------------------------------------------------------------------------------------------

void Sidplayer::solo1Toggled( bool on )
{
    if ( on )
    {
        if ( Solo2->isOn() )
            Solo2->setOn( false );
        else if ( Solo3->isOn() )
            Solo3->setOn( false );
        else if ( Solo4->isOn() )
            Solo4->setOn( false );

        Mute1->setChecked( false );
        Mute2->setChecked( true );
        Mute3->setChecked( true );
        Mute4->setChecked( true );
#ifdef SOLO_GET_RIGHT_HACK
        Solo1->setOn( true ); // because of soloGetRight() hack
#endif
    }
    else
    {
        Mute1->setChecked( false );
        Mute2->setChecked( false );
        Mute3->setChecked( false );
        Mute4->setChecked( false );
    }
}

void Sidplayer::solo2Toggled( bool on )
{
    if ( on )
    {
        if ( Solo1->isOn() )
            Solo1->setOn( false );
        else if ( Solo3->isOn() )
            Solo3->setOn( false );
        else if ( Solo4->isOn() )
            Solo4->setOn( false );

        Mute1->setChecked( true );
        Mute2->setChecked( false );
        Mute3->setChecked( true );
        Mute4->setChecked( true );
#ifdef SOLO_GET_RIGHT_HACK
        Solo2->setOn( true ); // because of soloGetRight() hack
#endif
    }
    else
    {
        Mute1->setChecked( false );
        Mute2->setChecked( false );
        Mute3->setChecked( false );
        Mute4->setChecked( false );
    }
}

void Sidplayer::solo3Toggled( bool on )
{
    if ( on )
    {
        if ( Solo1->isOn() )
            Solo1->setOn( false );
        else if ( Solo2->isOn() )
            Solo2->setOn( false );
        else if ( Solo4->isOn() )
            Solo4->setOn( false );

        Mute1->setChecked( true );
        Mute2->setChecked( true );
        Mute3->setChecked( false );
        Mute4->setChecked( true );
#ifdef SOLO_GET_RIGHT_HACK
        Solo3->setOn( true );
#endif
    }
    else
    {
        Mute1->setChecked( false );
        Mute2->setChecked( false );
        Mute3->setChecked( false );
        Mute4->setChecked( false );
    }
}

void Sidplayer::solo4Toggled( bool on )
{
    if ( on )
    {
        if ( Solo1->isOn() )
            Solo1->setOn( false );
        else if ( Solo2->isOn() )
            Solo2->setOn( false );
        else if ( Solo3->isOn() )
            Solo3->setOn( false );

        Mute1->setChecked( true );
        Mute2->setChecked( true );
        Mute3->setChecked( true );
        Mute4->setChecked( false );
#ifdef SOLO_GET_RIGHT_HACK
        Solo4->setOn( true ); // because of soloGetRight() hack
#endif
    }
    else
    {
        Mute1->setChecked( false );
        Mute2->setChecked( false );
        Mute3->setChecked( false );
        Mute4->setChecked( false );
    }
}
